'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.registry = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

exports.appendEntry = appendEntry;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FAKE_MODULE_NAME = 'webpack-inject-plugin.module.js';
var FAKE_LOADER_NAME = 'webpack-inject-plugin.loader.js';

function appendEntry(originalEntry, newEntry) {
	if (_lodash2.default.isArray(originalEntry)) {
		return [].concat((0, _toConsumableArray3.default)(originalEntry), [newEntry]);
	}

	if (_lodash2.default.isObject(originalEntry)) {
		return _lodash2.default.mapValues(originalEntry, _lodash2.default.partial(appendEntry, _lodash2.default, newEntry));
	}

	if (_lodash2.default.isString(originalEntry)) {
		return [originalEntry, newEntry];
	}

	return newEntry;
}

var registry = exports.registry = {};

var WebpackInjectPlugin = function () {
	function WebpackInjectPlugin(loader) {
		(0, _classCallCheck3.default)(this, WebpackInjectPlugin);

		this.loader = _lodash2.default.isFunction(loader) ? loader : _lodash2.default.noop;
	}

	(0, _createClass3.default)(WebpackInjectPlugin, [{
		key: 'apply',
		value: function apply(compiler) {
			var moduleLocation = _path2.default.join(__dirname, FAKE_MODULE_NAME);

			var id = _lodash2.default.uniq();

			registry[id] = this.loader;

			// Append an entry for our fake module
			compiler.options.entry = appendEntry(compiler.options.entry, moduleLocation);

			// Add a loader for our fake module
			// The loader will be responsible for injecting the code for us
			if (_lodash2.default.isUndefined(compiler.options.module)) {
				compiler.options.module = {};
			}

			if (_lodash2.default.isUndefined(compiler.options.module.rules)) {
				compiler.options.module.rules = [];
			}

			compiler.options.module.rules.push({
				test: /webpack-inject-plugin\.module\.js$/,
				use: [{
					loader: _path2.default.resolve(__dirname, FAKE_LOADER_NAME),
					query: { id: id }
				}]
			});
		}
	}]);
	return WebpackInjectPlugin;
}();

exports.default = WebpackInjectPlugin;